/* tcpclient-rpc_serializables.c generated by valac 0.20.1, the Vala compiler
 * generated from tcpclient-rpc_serializables.vala, do not modify */

/*
 *  This file is part of Netsukuku.
 *  (c) Copyright 2014 Luca Dionisi aka lukisi <luca.dionisi@gmail.com>
 *
 *  Netsukuku is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Netsukuku is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with Netsukuku.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <glib.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <gee.h>


#define ZCD_TYPE_ISERIALIZABLE (zcd_iserializable_get_type ())
#define ZCD_ISERIALIZABLE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), ZCD_TYPE_ISERIALIZABLE, zcdISerializable))
#define ZCD_IS_ISERIALIZABLE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), ZCD_TYPE_ISERIALIZABLE))
#define ZCD_ISERIALIZABLE_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), ZCD_TYPE_ISERIALIZABLE, zcdISerializableIface))

typedef struct _zcdISerializable zcdISerializable;
typedef struct _zcdISerializableIface zcdISerializableIface;

#define ZCD_TYPE_REMOTABLE_EXCEPTION (zcd_remotable_exception_get_type ())
#define ZCD_REMOTABLE_EXCEPTION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), ZCD_TYPE_REMOTABLE_EXCEPTION, zcdRemotableException))
#define ZCD_REMOTABLE_EXCEPTION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), ZCD_TYPE_REMOTABLE_EXCEPTION, zcdRemotableExceptionClass))
#define ZCD_IS_REMOTABLE_EXCEPTION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), ZCD_TYPE_REMOTABLE_EXCEPTION))
#define ZCD_IS_REMOTABLE_EXCEPTION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), ZCD_TYPE_REMOTABLE_EXCEPTION))
#define ZCD_REMOTABLE_EXCEPTION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), ZCD_TYPE_REMOTABLE_EXCEPTION, zcdRemotableExceptionClass))

typedef struct _zcdRemotableException zcdRemotableException;
typedef struct _zcdRemotableExceptionClass zcdRemotableExceptionClass;
typedef struct _zcdRemotableExceptionPrivate zcdRemotableExceptionPrivate;
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_variant_unref0(var) ((var == NULL) ? NULL : (var = (g_variant_unref (var), NULL)))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

#define ZCD_TYPE_REMOTE_CALL (zcd_remote_call_get_type ())
#define ZCD_REMOTE_CALL(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), ZCD_TYPE_REMOTE_CALL, zcdRemoteCall))
#define ZCD_REMOTE_CALL_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), ZCD_TYPE_REMOTE_CALL, zcdRemoteCallClass))
#define ZCD_IS_REMOTE_CALL(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), ZCD_TYPE_REMOTE_CALL))
#define ZCD_IS_REMOTE_CALL_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), ZCD_TYPE_REMOTE_CALL))
#define ZCD_REMOTE_CALL_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), ZCD_TYPE_REMOTE_CALL, zcdRemoteCallClass))

typedef struct _zcdRemoteCall zcdRemoteCall;
typedef struct _zcdRemoteCallClass zcdRemoteCallClass;
typedef struct _zcdRemoteCallPrivate zcdRemoteCallPrivate;

#define ZCD_TYPE_BUFFER_OWNER (zcd_buffer_owner_get_type ())
#define ZCD_BUFFER_OWNER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), ZCD_TYPE_BUFFER_OWNER, zcdBufferOwner))
#define ZCD_BUFFER_OWNER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), ZCD_TYPE_BUFFER_OWNER, zcdBufferOwnerClass))
#define ZCD_IS_BUFFER_OWNER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), ZCD_TYPE_BUFFER_OWNER))
#define ZCD_IS_BUFFER_OWNER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), ZCD_TYPE_BUFFER_OWNER))
#define ZCD_BUFFER_OWNER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), ZCD_TYPE_BUFFER_OWNER, zcdBufferOwnerClass))

typedef struct _zcdBufferOwner zcdBufferOwner;
typedef struct _zcdBufferOwnerClass zcdBufferOwnerClass;
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define _vala_assert(expr, msg) if G_LIKELY (expr) ; else g_assertion_message_expr (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);

/** This is an error that any remotable method could throw.
      */
typedef enum  {
	ZCD_RPC_ERROR_FUNCTION_NOT_REMOTABLE,
	ZCD_RPC_ERROR_MALFORMED_PACKET,
	ZCD_RPC_ERROR_NETWORK_ERROR,
	ZCD_RPC_ERROR_NOT_VALID_MAP_YET,
	ZCD_RPC_ERROR_DROP,
	ZCD_RPC_ERROR_SERIALIZER_ERROR,
	ZCD_RPC_ERROR_GENERIC
} zcdRPCError;
#define ZCD_RPC_ERROR zcd_rpc_error_quark ()
typedef enum  {
	ZCD_SERIALIZER_ERROR_GENERIC
} zcdSerializerError;
#define ZCD_SERIALIZER_ERROR zcd_serializer_error_quark ()
struct _zcdISerializableIface {
	GTypeInterface parent_iface;
	GVariant* (*serialize_to_variant) (zcdISerializable* self);
	void (*deserialize_from_variant) (zcdISerializable* self, GVariant* v, GError** error);
};

struct _zcdRemotableException {
	GObject parent_instance;
	zcdRemotableExceptionPrivate * priv;
	gchar* message;
	gchar* code;
	gchar* domain;
};

struct _zcdRemotableExceptionClass {
	GObjectClass parent_class;
};

struct _zcdRemoteCall {
	GObject parent_instance;
	zcdRemoteCallPrivate * priv;
	gchar* method_name;
};

struct _zcdRemoteCallClass {
	GObjectClass parent_class;
};

struct _zcdRemoteCallPrivate {
	GeeArrayList* _elements;
	GeeArrayList* _elements_deserialized;
	GeeList* _elements_deserialized_ro;
};


static gpointer zcd_remotable_exception_parent_class = NULL;
static zcdISerializableIface* zcd_remotable_exception_zcd_iserializable_parent_iface = NULL;
static gpointer zcd_remote_call_parent_class = NULL;
static zcdISerializableIface* zcd_remote_call_zcd_iserializable_parent_iface = NULL;

GQuark zcd_rpc_error_quark (void);
GQuark zcd_serializer_error_quark (void);
GType zcd_iserializable_get_type (void) G_GNUC_CONST;
GType zcd_remotable_exception_get_type (void) G_GNUC_CONST;
enum  {
	ZCD_REMOTABLE_EXCEPTION_DUMMY_PROPERTY
};
static GVariant* zcd_remotable_exception_real_serialize_to_variant (zcdISerializable* base);
GVariant* zcd_serializer_string_to_variant (const gchar* s);
GVariant* zcd_serializer_tuple_to_variant_3 (GVariant* v0, GVariant* v1, GVariant* v2);
static void zcd_remotable_exception_real_deserialize_from_variant (zcdISerializable* base, GVariant* v, GError** error);
void zcd_serializer_variant_to_tuple_3 (GVariant* v, GVariant** v0, GVariant** v1, GVariant** v2);
gchar* zcd_serializer_variant_to_string (GVariant* v);
gchar* zcd_remotable_exception_to_string (zcdRemotableException* self);
zcdRemotableException* zcd_remotable_exception_new (void);
zcdRemotableException* zcd_remotable_exception_construct (GType object_type);
static void zcd_remotable_exception_finalize (GObject* obj);
zcdISerializable* zcd_filter_exception (zcdISerializable* ret, GError** error);
GType zcd_remote_call_get_type (void) G_GNUC_CONST;
GType zcd_buffer_owner_get_type (void) G_GNUC_CONST;
#define ZCD_REMOTE_CALL_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), ZCD_TYPE_REMOTE_CALL, zcdRemoteCallPrivate))
enum  {
	ZCD_REMOTE_CALL_DUMMY_PROPERTY,
	ZCD_REMOTE_CALL_PARAMETERS
};
zcdRemoteCall* zcd_remote_call_new (void);
zcdRemoteCall* zcd_remote_call_construct (GType object_type);
void zcd_remote_call_add_parameter (zcdRemoteCall* self, zcdISerializable* arg);
guchar* zcd_iserializable_serialize (zcdISerializable* self, int* result_length1);
zcdBufferOwner* zcd_buffer_owner_new (guchar* seed, int seed_length1);
zcdBufferOwner* zcd_buffer_owner_construct (GType object_type, guchar* seed, int seed_length1);
static gboolean zcd_remote_call_not_impl_equal_func (GObject* a, GObject* b);
static GVariant* zcd_remote_call_real_serialize_to_variant (zcdISerializable* base);
GVariant* zcd_serializer_uchar_array_to_variant (guchar* auc, int auc_length1);
guchar* zcd_buffer_owner_get_buf (zcdBufferOwner* self, int* result_length1);
GVariant* zcd_serializer_variant_array_to_variant (GVariant** av, int av_length1);
GVariant* zcd_serializer_tuple_to_variant (GVariant* v0, GVariant* v1);
static void zcd_remote_call_real_deserialize_from_variant (zcdISerializable* base, GVariant* v, GError** error);
void zcd_serializer_variant_to_tuple (GVariant* v, GVariant** v0, GVariant** v1);
GVariant** zcd_serializer_variant_to_variant_array (GVariant* v, int* result_length1);
guchar* zcd_serializer_variant_to_uchar_array (GVariant* v, int* result_length1);
gchar* zcd_remote_call_to_string (zcdRemoteCall* self);
gchar* zcd_iserializable_typename (guchar* ser, int ser_length1);
GeeList* zcd_remote_call_get_parameters (zcdRemoteCall* self);
zcdISerializable* zcd_iserializable_deserialize (guchar* ser, int ser_length1, GError** error);
void zcd_log_error (const gchar* msg);
static void zcd_remote_call_finalize (GObject* obj);
static void _vala_zcd_remote_call_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec);
static void _vala_array_destroy (gpointer array, gint array_length, GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array, gint array_length, GDestroyNotify destroy_func);


GQuark zcd_rpc_error_quark (void) {
	return g_quark_from_static_string ("zcd_rpc_error-quark");
}


static GVariant* zcd_remotable_exception_real_serialize_to_variant (zcdISerializable* base) {
	zcdRemotableException * self;
	GVariant* result = NULL;
	const gchar* _tmp0_;
	GVariant* _tmp1_ = NULL;
	GVariant* v0;
	const gchar* _tmp2_;
	GVariant* _tmp3_ = NULL;
	GVariant* v1;
	const gchar* _tmp4_;
	GVariant* _tmp5_ = NULL;
	GVariant* v2;
	GVariant* _tmp6_ = NULL;
	GVariant* vret;
	self = (zcdRemotableException*) base;
	_tmp0_ = self->message;
	_tmp1_ = zcd_serializer_string_to_variant (_tmp0_);
	v0 = _tmp1_;
	_tmp2_ = self->code;
	_tmp3_ = zcd_serializer_string_to_variant (_tmp2_);
	v1 = _tmp3_;
	_tmp4_ = self->domain;
	_tmp5_ = zcd_serializer_string_to_variant (_tmp4_);
	v2 = _tmp5_;
	_tmp6_ = zcd_serializer_tuple_to_variant_3 (v0, v1, v2);
	vret = _tmp6_;
	result = vret;
	_g_variant_unref0 (v2);
	_g_variant_unref0 (v1);
	_g_variant_unref0 (v0);
	return result;
}


static void zcd_remotable_exception_real_deserialize_from_variant (zcdISerializable* base, GVariant* v, GError** error) {
	zcdRemotableException * self;
	GVariant* v0 = NULL;
	GVariant* v1 = NULL;
	GVariant* v2 = NULL;
	GVariant* _tmp0_;
	GVariant* _tmp1_ = NULL;
	GVariant* _tmp2_ = NULL;
	GVariant* _tmp3_ = NULL;
	gchar* _tmp4_ = NULL;
	gchar* _tmp5_ = NULL;
	gchar* _tmp6_ = NULL;
	self = (zcdRemotableException*) base;
	g_return_if_fail (v != NULL);
	_tmp0_ = v;
	zcd_serializer_variant_to_tuple_3 (_tmp0_, &_tmp1_, &_tmp2_, &_tmp3_);
	_g_variant_unref0 (v0);
	v0 = _tmp1_;
	_g_variant_unref0 (v1);
	v1 = _tmp2_;
	_g_variant_unref0 (v2);
	v2 = _tmp3_;
	_tmp4_ = zcd_serializer_variant_to_string (v0);
	_g_free0 (self->message);
	self->message = _tmp4_;
	_tmp5_ = zcd_serializer_variant_to_string (v1);
	_g_free0 (self->code);
	self->code = _tmp5_;
	_tmp6_ = zcd_serializer_variant_to_string (v2);
	_g_free0 (self->domain);
	self->domain = _tmp6_;
	_g_variant_unref0 (v2);
	_g_variant_unref0 (v1);
	_g_variant_unref0 (v0);
}


static const gchar* string_to_string (const gchar* self) {
	const gchar* result = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	result = self;
	return result;
}


gchar* zcd_remotable_exception_to_string (zcdRemotableException* self) {
	gchar* result = NULL;
	const gchar* _tmp0_;
	const gchar* _tmp1_ = NULL;
	const gchar* _tmp2_;
	const gchar* _tmp3_ = NULL;
	const gchar* _tmp4_;
	const gchar* _tmp5_ = NULL;
	gchar* _tmp6_ = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->domain;
	_tmp1_ = string_to_string (_tmp0_);
	_tmp2_ = self->code;
	_tmp3_ = string_to_string (_tmp2_);
	_tmp4_ = self->message;
	_tmp5_ = string_to_string (_tmp4_);
	_tmp6_ = g_strconcat (_tmp1_, ".", _tmp3_, " '", _tmp5_, "'", NULL);
	result = _tmp6_;
	return result;
}


zcdRemotableException* zcd_remotable_exception_construct (GType object_type) {
	zcdRemotableException * self = NULL;
	self = (zcdRemotableException*) g_object_new (object_type, NULL);
	return self;
}


zcdRemotableException* zcd_remotable_exception_new (void) {
	return zcd_remotable_exception_construct (ZCD_TYPE_REMOTABLE_EXCEPTION);
}


static void zcd_remotable_exception_class_init (zcdRemotableExceptionClass * klass) {
	zcd_remotable_exception_parent_class = g_type_class_peek_parent (klass);
	G_OBJECT_CLASS (klass)->finalize = zcd_remotable_exception_finalize;
}


static void zcd_remotable_exception_zcd_iserializable_interface_init (zcdISerializableIface * iface) {
	zcd_remotable_exception_zcd_iserializable_parent_iface = g_type_interface_peek_parent (iface);
	iface->serialize_to_variant = (GVariant* (*)(zcdISerializable*)) zcd_remotable_exception_real_serialize_to_variant;
	iface->deserialize_from_variant = (void (*)(zcdISerializable*, GVariant*, GError**)) zcd_remotable_exception_real_deserialize_from_variant;
}


static void zcd_remotable_exception_instance_init (zcdRemotableException * self) {
}


static void zcd_remotable_exception_finalize (GObject* obj) {
	zcdRemotableException * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, ZCD_TYPE_REMOTABLE_EXCEPTION, zcdRemotableException);
	_g_free0 (self->message);
	_g_free0 (self->code);
	_g_free0 (self->domain);
	G_OBJECT_CLASS (zcd_remotable_exception_parent_class)->finalize (obj);
}


/** This class represents a RPCError or any other error that is thrown
      * by the remotable method.
      */
GType zcd_remotable_exception_get_type (void) {
	static volatile gsize zcd_remotable_exception_type_id__volatile = 0;
	if (g_once_init_enter (&zcd_remotable_exception_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (zcdRemotableExceptionClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) zcd_remotable_exception_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (zcdRemotableException), 0, (GInstanceInitFunc) zcd_remotable_exception_instance_init, NULL };
		static const GInterfaceInfo zcd_iserializable_info = { (GInterfaceInitFunc) zcd_remotable_exception_zcd_iserializable_interface_init, (GInterfaceFinalizeFunc) NULL, NULL};
		GType zcd_remotable_exception_type_id;
		zcd_remotable_exception_type_id = g_type_register_static (G_TYPE_OBJECT, "zcdRemotableException", &g_define_type_info, 0);
		g_type_add_interface_static (zcd_remotable_exception_type_id, ZCD_TYPE_ISERIALIZABLE, &zcd_iserializable_info);
		g_once_init_leave (&zcd_remotable_exception_type_id__volatile, zcd_remotable_exception_type_id);
	}
	return zcd_remotable_exception_type_id__volatile;
}


static gpointer _g_object_ref0 (gpointer self) {
	return self ? g_object_ref (self) : NULL;
}


zcdISerializable* zcd_filter_exception (zcdISerializable* ret, GError** error) {
	zcdISerializable* result = NULL;
	zcdISerializable* _tmp0_;
	GType _tmp1_ = 0UL;
	gboolean _tmp2_ = FALSE;
	zcdISerializable* _tmp66_;
	zcdISerializable* _tmp67_;
	GError * _inner_error_ = NULL;
	g_return_val_if_fail (ret != NULL, NULL);
	_tmp0_ = ret;
	_tmp1_ = G_TYPE_FROM_INSTANCE ((GObject*) _tmp0_);
	_tmp2_ = g_type_is_a (_tmp1_, ZCD_TYPE_REMOTABLE_EXCEPTION);
	if (_tmp2_) {
		zcdISerializable* _tmp3_;
		zcdRemotableException* _tmp4_;
		zcdRemotableException* e;
		zcdRemotableException* _tmp5_;
		const gchar* _tmp6_;
		zcdRemotableException* _tmp47_;
		const gchar* _tmp48_;
		_tmp3_ = ret;
		_tmp4_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp3_, ZCD_TYPE_REMOTABLE_EXCEPTION, zcdRemotableException));
		e = _tmp4_;
		_tmp5_ = e;
		_tmp6_ = _tmp5_->domain;
		if (g_strcmp0 (_tmp6_, "RPCError") == 0) {
			zcdRemotableException* _tmp7_;
			const gchar* _tmp8_;
			zcdRemotableException* _tmp12_;
			const gchar* _tmp13_;
			zcdRemotableException* _tmp17_;
			const gchar* _tmp18_;
			zcdRemotableException* _tmp22_;
			const gchar* _tmp23_;
			zcdRemotableException* _tmp27_;
			const gchar* _tmp28_;
			zcdRemotableException* _tmp32_;
			const gchar* _tmp33_;
			zcdRemotableException* _tmp37_;
			const gchar* _tmp38_;
			const gchar* _tmp39_ = NULL;
			zcdRemotableException* _tmp40_;
			const gchar* _tmp41_;
			const gchar* _tmp42_ = NULL;
			gchar* _tmp43_ = NULL;
			gchar* _tmp44_;
			GError* _tmp45_;
			GError* _tmp46_;
			_tmp7_ = e;
			_tmp8_ = _tmp7_->code;
			if (g_strcmp0 (_tmp8_, "FUNCTION_NOT_REMOTABLE") == 0) {
				zcdRemotableException* _tmp9_;
				const gchar* _tmp10_;
				GError* _tmp11_;
				_tmp9_ = e;
				_tmp10_ = _tmp9_->message;
				_tmp11_ = g_error_new_literal (ZCD_RPC_ERROR, ZCD_RPC_ERROR_FUNCTION_NOT_REMOTABLE, _tmp10_);
				_inner_error_ = _tmp11_;
				if (_inner_error_->domain == ZCD_RPC_ERROR) {
					g_propagate_error (error, _inner_error_);
					_g_object_unref0 (e);
					return NULL;
				} else {
					_g_object_unref0 (e);
					g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
					g_clear_error (&_inner_error_);
					return NULL;
				}
			}
			_tmp12_ = e;
			_tmp13_ = _tmp12_->code;
			if (g_strcmp0 (_tmp13_, "MALFORMED_PACKET") == 0) {
				zcdRemotableException* _tmp14_;
				const gchar* _tmp15_;
				GError* _tmp16_;
				_tmp14_ = e;
				_tmp15_ = _tmp14_->message;
				_tmp16_ = g_error_new_literal (ZCD_RPC_ERROR, ZCD_RPC_ERROR_MALFORMED_PACKET, _tmp15_);
				_inner_error_ = _tmp16_;
				if (_inner_error_->domain == ZCD_RPC_ERROR) {
					g_propagate_error (error, _inner_error_);
					_g_object_unref0 (e);
					return NULL;
				} else {
					_g_object_unref0 (e);
					g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
					g_clear_error (&_inner_error_);
					return NULL;
				}
			}
			_tmp17_ = e;
			_tmp18_ = _tmp17_->code;
			if (g_strcmp0 (_tmp18_, "NETWORK_ERROR") == 0) {
				zcdRemotableException* _tmp19_;
				const gchar* _tmp20_;
				GError* _tmp21_;
				_tmp19_ = e;
				_tmp20_ = _tmp19_->message;
				_tmp21_ = g_error_new_literal (ZCD_RPC_ERROR, ZCD_RPC_ERROR_NETWORK_ERROR, _tmp20_);
				_inner_error_ = _tmp21_;
				if (_inner_error_->domain == ZCD_RPC_ERROR) {
					g_propagate_error (error, _inner_error_);
					_g_object_unref0 (e);
					return NULL;
				} else {
					_g_object_unref0 (e);
					g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
					g_clear_error (&_inner_error_);
					return NULL;
				}
			}
			_tmp22_ = e;
			_tmp23_ = _tmp22_->code;
			if (g_strcmp0 (_tmp23_, "NOT_VALID_MAP_YET") == 0) {
				zcdRemotableException* _tmp24_;
				const gchar* _tmp25_;
				GError* _tmp26_;
				_tmp24_ = e;
				_tmp25_ = _tmp24_->message;
				_tmp26_ = g_error_new_literal (ZCD_RPC_ERROR, ZCD_RPC_ERROR_NOT_VALID_MAP_YET, _tmp25_);
				_inner_error_ = _tmp26_;
				if (_inner_error_->domain == ZCD_RPC_ERROR) {
					g_propagate_error (error, _inner_error_);
					_g_object_unref0 (e);
					return NULL;
				} else {
					_g_object_unref0 (e);
					g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
					g_clear_error (&_inner_error_);
					return NULL;
				}
			}
			_tmp27_ = e;
			_tmp28_ = _tmp27_->code;
			if (g_strcmp0 (_tmp28_, "SERIALIZER_ERROR") == 0) {
				zcdRemotableException* _tmp29_;
				const gchar* _tmp30_;
				GError* _tmp31_;
				_tmp29_ = e;
				_tmp30_ = _tmp29_->message;
				_tmp31_ = g_error_new_literal (ZCD_RPC_ERROR, ZCD_RPC_ERROR_SERIALIZER_ERROR, _tmp30_);
				_inner_error_ = _tmp31_;
				if (_inner_error_->domain == ZCD_RPC_ERROR) {
					g_propagate_error (error, _inner_error_);
					_g_object_unref0 (e);
					return NULL;
				} else {
					_g_object_unref0 (e);
					g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
					g_clear_error (&_inner_error_);
					return NULL;
				}
			}
			_tmp32_ = e;
			_tmp33_ = _tmp32_->code;
			if (g_strcmp0 (_tmp33_, "GENERIC") == 0) {
				zcdRemotableException* _tmp34_;
				const gchar* _tmp35_;
				GError* _tmp36_;
				_tmp34_ = e;
				_tmp35_ = _tmp34_->message;
				_tmp36_ = g_error_new_literal (ZCD_RPC_ERROR, ZCD_RPC_ERROR_GENERIC, _tmp35_);
				_inner_error_ = _tmp36_;
				if (_inner_error_->domain == ZCD_RPC_ERROR) {
					g_propagate_error (error, _inner_error_);
					_g_object_unref0 (e);
					return NULL;
				} else {
					_g_object_unref0 (e);
					g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
					g_clear_error (&_inner_error_);
					return NULL;
				}
			}
			_tmp37_ = e;
			_tmp38_ = _tmp37_->code;
			_tmp39_ = string_to_string (_tmp38_);
			_tmp40_ = e;
			_tmp41_ = _tmp40_->message;
			_tmp42_ = string_to_string (_tmp41_);
			_tmp43_ = g_strconcat ("Unexpected RPCError code ", _tmp39_, ": ", _tmp42_, NULL);
			_tmp44_ = _tmp43_;
			_tmp45_ = g_error_new_literal (ZCD_RPC_ERROR, ZCD_RPC_ERROR_GENERIC, _tmp44_);
			_tmp46_ = _tmp45_;
			_g_free0 (_tmp44_);
			_inner_error_ = _tmp46_;
			if (_inner_error_->domain == ZCD_RPC_ERROR) {
				g_propagate_error (error, _inner_error_);
				_g_object_unref0 (e);
				return NULL;
			} else {
				_g_object_unref0 (e);
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
				g_clear_error (&_inner_error_);
				return NULL;
			}
		}
		_tmp47_ = e;
		_tmp48_ = _tmp47_->domain;
		if (g_strcmp0 (_tmp48_, "SerializerError") == 0) {
			zcdRemotableException* _tmp49_;
			const gchar* _tmp50_;
			const gchar* _tmp51_ = NULL;
			zcdRemotableException* _tmp52_;
			const gchar* _tmp53_;
			const gchar* _tmp54_ = NULL;
			gchar* _tmp55_ = NULL;
			gchar* _tmp56_;
			GError* _tmp57_;
			GError* _tmp58_;
			_tmp49_ = e;
			_tmp50_ = _tmp49_->code;
			_tmp51_ = string_to_string (_tmp50_);
			_tmp52_ = e;
			_tmp53_ = _tmp52_->message;
			_tmp54_ = string_to_string (_tmp53_);
			_tmp55_ = g_strconcat ("SerializerError code ", _tmp51_, ": ", _tmp54_, NULL);
			_tmp56_ = _tmp55_;
			_tmp57_ = g_error_new_literal (ZCD_RPC_ERROR, ZCD_RPC_ERROR_GENERIC, _tmp56_);
			_tmp58_ = _tmp57_;
			_g_free0 (_tmp56_);
			_inner_error_ = _tmp58_;
			if (_inner_error_->domain == ZCD_RPC_ERROR) {
				g_propagate_error (error, _inner_error_);
				_g_object_unref0 (e);
				return NULL;
			} else {
				_g_object_unref0 (e);
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
				g_clear_error (&_inner_error_);
				return NULL;
			}
		} else {
			zcdRemotableException* _tmp59_;
			gchar* _tmp60_ = NULL;
			gchar* _tmp61_;
			gchar* _tmp62_ = NULL;
			gchar* _tmp63_;
			GError* _tmp64_;
			GError* _tmp65_;
			_tmp59_ = e;
			_tmp60_ = zcd_remotable_exception_to_string (_tmp59_);
			_tmp61_ = _tmp60_;
			_tmp62_ = g_strconcat ("Unexpected error ", _tmp61_, NULL);
			_tmp63_ = _tmp62_;
			_tmp64_ = g_error_new_literal (ZCD_RPC_ERROR, ZCD_RPC_ERROR_GENERIC, _tmp63_);
			_tmp65_ = _tmp64_;
			_g_free0 (_tmp63_);
			_g_free0 (_tmp61_);
			_inner_error_ = _tmp65_;
			if (_inner_error_->domain == ZCD_RPC_ERROR) {
				g_propagate_error (error, _inner_error_);
				_g_object_unref0 (e);
				return NULL;
			} else {
				_g_object_unref0 (e);
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
				g_clear_error (&_inner_error_);
				return NULL;
			}
		}
		_g_object_unref0 (e);
	}
	_tmp66_ = ret;
	_tmp67_ = _g_object_ref0 (_tmp66_);
	result = _tmp67_;
	return result;
}


zcdRemoteCall* zcd_remote_call_construct (GType object_type) {
	zcdRemoteCall * self = NULL;
	GeeArrayList* _tmp0_;
	self = (zcdRemoteCall*) g_object_new (object_type, NULL);
	_tmp0_ = gee_array_list_new (ZCD_TYPE_BUFFER_OWNER, (GBoxedCopyFunc) g_object_ref, g_object_unref, NULL, NULL, NULL);
	_g_object_unref0 (self->priv->_elements);
	self->priv->_elements = _tmp0_;
	return self;
}


zcdRemoteCall* zcd_remote_call_new (void) {
	return zcd_remote_call_construct (ZCD_TYPE_REMOTE_CALL);
}


void zcd_remote_call_add_parameter (zcdRemoteCall* self, zcdISerializable* arg) {
	zcdISerializable* _tmp0_;
	gint _tmp1_ = 0;
	guchar* _tmp2_ = NULL;
	guchar* ser;
	gint ser_length1;
	gint _ser_size_;
	zcdBufferOwner* _tmp3_;
	zcdBufferOwner* buf;
	GeeArrayList* _tmp4_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (arg != NULL);
	_g_object_unref0 (self->priv->_elements_deserialized);
	self->priv->_elements_deserialized = NULL;
	_tmp0_ = arg;
	_tmp2_ = zcd_iserializable_serialize (_tmp0_, &_tmp1_);
	ser = _tmp2_;
	ser_length1 = _tmp1_;
	_ser_size_ = ser_length1;
	_tmp3_ = zcd_buffer_owner_new (ser, ser_length1);
	buf = _tmp3_;
	_tmp4_ = self->priv->_elements;
	gee_abstract_collection_add ((GeeAbstractCollection*) _tmp4_, buf);
	_g_object_unref0 (buf);
	ser = (g_free (ser), NULL);
}


static gboolean zcd_remote_call_not_impl_equal_func (GObject* a, GObject* b) {
	gboolean result = FALSE;
	gchar* _tmp0_;
	gchar* astr;
	GObject* _tmp1_;
	gchar* _tmp6_;
	gchar* bstr;
	GObject* _tmp7_;
	const gchar* _tmp12_;
	const gchar* _tmp13_ = NULL;
	const gchar* _tmp14_;
	const gchar* _tmp15_ = NULL;
	gchar* _tmp16_ = NULL;
	gchar* _tmp17_;
	_tmp0_ = g_strdup ("null");
	astr = _tmp0_;
	_tmp1_ = a;
	if (_tmp1_ != NULL) {
		GObject* _tmp2_;
		GType _tmp3_ = 0UL;
		const gchar* _tmp4_ = NULL;
		gchar* _tmp5_;
		_tmp2_ = a;
		_tmp3_ = G_TYPE_FROM_INSTANCE (_tmp2_);
		_tmp4_ = g_type_name (_tmp3_);
		_tmp5_ = g_strdup (_tmp4_);
		_g_free0 (astr);
		astr = _tmp5_;
	}
	_tmp6_ = g_strdup ("null");
	bstr = _tmp6_;
	_tmp7_ = b;
	if (_tmp7_ != NULL) {
		GObject* _tmp8_;
		GType _tmp9_ = 0UL;
		const gchar* _tmp10_ = NULL;
		gchar* _tmp11_;
		_tmp8_ = b;
		_tmp9_ = G_TYPE_FROM_INSTANCE (_tmp8_);
		_tmp10_ = g_type_name (_tmp9_);
		_tmp11_ = g_strdup (_tmp10_);
		_g_free0 (bstr);
		bstr = _tmp11_;
	}
	_tmp12_ = astr;
	_tmp13_ = string_to_string (_tmp12_);
	_tmp14_ = bstr;
	_tmp15_ = string_to_string (_tmp14_);
	_tmp16_ = g_strconcat ("equal_func not implemented: compare between ", _tmp13_, " and ", _tmp15_, NULL);
	_tmp17_ = _tmp16_;
	g_error ("tcpclient-rpc_serializables.vala:132: %s", _tmp17_);
	_g_free0 (_tmp17_);
	_g_free0 (bstr);
	_g_free0 (astr);
	return result;
}


static gpointer _g_variant_ref0 (gpointer self) {
	return self ? g_variant_ref (self) : NULL;
}


static GVariant* zcd_remote_call_real_serialize_to_variant (zcdISerializable* base) {
	zcdRemoteCall * self;
	GVariant* result = NULL;
	GeeArrayList* _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
	self = (zcdRemoteCall*) base;
	_tmp0_ = self->priv->_elements;
	_tmp1_ = gee_abstract_collection_get_size ((GeeCollection*) _tmp0_);
	_tmp2_ = _tmp1_;
	if (_tmp2_ > 0) {
		GeeArrayList* _tmp3_;
		gint _tmp4_;
		gint _tmp5_;
		GVariant** _tmp6_ = NULL;
		GVariant** var_elements;
		gint var_elements_length1;
		gint _var_elements_size_;
		gint i;
		GVariant** _tmp27_;
		gint _tmp27__length1;
		GVariant* _tmp28_ = NULL;
		GVariant* v1;
		const gchar* _tmp29_;
		GVariant* _tmp30_ = NULL;
		GVariant* v2;
		GVariant* _tmp31_;
		GVariant* _tmp32_;
		GVariant* _tmp33_ = NULL;
		GVariant* vret;
		_tmp3_ = self->priv->_elements;
		_tmp4_ = gee_abstract_collection_get_size ((GeeCollection*) _tmp3_);
		_tmp5_ = _tmp4_;
		_tmp6_ = g_new0 (GVariant*, _tmp5_ + 1);
		var_elements = _tmp6_;
		var_elements_length1 = _tmp5_;
		_var_elements_size_ = var_elements_length1;
		i = 0;
		{
			GeeArrayList* _tmp7_;
			GeeArrayList* _tmp8_;
			GeeArrayList* _element_list;
			GeeArrayList* _tmp9_;
			gint _tmp10_;
			gint _tmp11_;
			gint _element_size;
			gint _element_index;
			_tmp7_ = self->priv->_elements;
			_tmp8_ = _g_object_ref0 (_tmp7_);
			_element_list = _tmp8_;
			_tmp9_ = _element_list;
			_tmp10_ = gee_abstract_collection_get_size ((GeeCollection*) _tmp9_);
			_tmp11_ = _tmp10_;
			_element_size = _tmp11_;
			_element_index = -1;
			while (TRUE) {
				gint _tmp12_;
				gint _tmp13_;
				gint _tmp14_;
				GeeArrayList* _tmp15_;
				gint _tmp16_;
				gpointer _tmp17_ = NULL;
				zcdBufferOwner* element;
				zcdBufferOwner* _tmp18_;
				guchar* _tmp19_;
				gint _tmp19__length1;
				guchar* _tmp20_;
				gint _tmp20__length1;
				GVariant* _tmp21_ = NULL;
				GVariant* v0;
				GVariant** _tmp22_;
				gint _tmp22__length1;
				gint _tmp23_;
				GVariant* _tmp24_;
				GVariant* _tmp25_;
				GVariant* _tmp26_;
				_tmp12_ = _element_index;
				_element_index = _tmp12_ + 1;
				_tmp13_ = _element_index;
				_tmp14_ = _element_size;
				if (!(_tmp13_ < _tmp14_)) {
					break;
				}
				_tmp15_ = _element_list;
				_tmp16_ = _element_index;
				_tmp17_ = gee_abstract_list_get ((GeeAbstractList*) _tmp15_, _tmp16_);
				element = (zcdBufferOwner*) _tmp17_;
				_tmp18_ = element;
				_tmp19_ = zcd_buffer_owner_get_buf (_tmp18_, &_tmp19__length1);
				_tmp20_ = _tmp19_;
				_tmp20__length1 = _tmp19__length1;
				_tmp21_ = zcd_serializer_uchar_array_to_variant (_tmp20_, _tmp20__length1);
				v0 = _tmp21_;
				_tmp22_ = var_elements;
				_tmp22__length1 = var_elements_length1;
				_tmp23_ = i;
				i = _tmp23_ + 1;
				_tmp24_ = v0;
				_tmp25_ = _g_variant_ref0 (_tmp24_);
				_g_variant_unref0 (_tmp22_[_tmp23_]);
				_tmp22_[_tmp23_] = _tmp25_;
				_tmp26_ = _tmp22_[_tmp23_];
				_g_variant_unref0 (v0);
				_g_object_unref0 (element);
			}
			_g_object_unref0 (_element_list);
		}
		_tmp27_ = var_elements;
		_tmp27__length1 = var_elements_length1;
		_tmp28_ = zcd_serializer_variant_array_to_variant (_tmp27_, _tmp27__length1);
		v1 = _tmp28_;
		_tmp29_ = self->method_name;
		_tmp30_ = zcd_serializer_string_to_variant (_tmp29_);
		v2 = _tmp30_;
		_tmp31_ = v1;
		_tmp32_ = v2;
		_tmp33_ = zcd_serializer_tuple_to_variant (_tmp31_, _tmp32_);
		vret = _tmp33_;
		result = vret;
		_g_variant_unref0 (v2);
		_g_variant_unref0 (v1);
		var_elements = (_vala_array_free (var_elements, var_elements_length1, (GDestroyNotify) g_variant_unref), NULL);
		return result;
	} else {
		const gchar* _tmp34_;
		GVariant* _tmp35_ = NULL;
		GVariant* v2;
		_tmp34_ = self->method_name;
		_tmp35_ = zcd_serializer_string_to_variant (_tmp34_);
		v2 = _tmp35_;
		result = v2;
		return result;
	}
}


static void zcd_remote_call_real_deserialize_from_variant (zcdISerializable* base, GVariant* v, GError** error) {
	zcdRemoteCall * self;
	GVariant* _tmp0_;
	const gchar* _tmp1_ = NULL;
	gchar* _tmp2_;
	gchar* vt;
	gboolean _tmp3_ = FALSE;
	const gchar* _tmp4_;
	gboolean _tmp6_;
	const gchar* _tmp7_;
	self = (zcdRemoteCall*) base;
	g_return_if_fail (v != NULL);
	_tmp0_ = v;
	_tmp1_ = g_variant_get_type_string (_tmp0_);
	_tmp2_ = g_strdup (_tmp1_);
	vt = _tmp2_;
	_tmp4_ = vt;
	if (g_strcmp0 (_tmp4_, "(vv)") == 0) {
		_tmp3_ = TRUE;
	} else {
		const gchar* _tmp5_;
		_tmp5_ = vt;
		_tmp3_ = g_strcmp0 (_tmp5_, "s") == 0;
	}
	_tmp6_ = _tmp3_;
	_vala_assert (_tmp6_, "vt == \"(vv)\" || vt == \"s\"");
	_tmp7_ = vt;
	if (g_strcmp0 (_tmp7_, "(vv)") == 0) {
		GVariant* v1 = NULL;
		GVariant* v2 = NULL;
		GVariant* _tmp8_;
		GVariant* _tmp9_ = NULL;
		GVariant* _tmp10_ = NULL;
		GVariant* _tmp11_;
		gchar* _tmp12_ = NULL;
		GVariant* _tmp13_;
		gint _tmp14_ = 0;
		GVariant** _tmp15_ = NULL;
		GVariant** var_elements;
		gint var_elements_length1;
		gint _var_elements_size_;
		GeeArrayList* _tmp16_;
		_tmp8_ = v;
		zcd_serializer_variant_to_tuple (_tmp8_, &_tmp9_, &_tmp10_);
		_g_variant_unref0 (v1);
		v1 = _tmp9_;
		_g_variant_unref0 (v2);
		v2 = _tmp10_;
		_tmp11_ = v2;
		_tmp12_ = zcd_serializer_variant_to_string (_tmp11_);
		_g_free0 (self->method_name);
		self->method_name = _tmp12_;
		_tmp13_ = v1;
		_tmp15_ = zcd_serializer_variant_to_variant_array (_tmp13_, &_tmp14_);
		var_elements = _tmp15_;
		var_elements_length1 = _tmp14_;
		_var_elements_size_ = var_elements_length1;
		_tmp16_ = gee_array_list_new (ZCD_TYPE_BUFFER_OWNER, (GBoxedCopyFunc) g_object_ref, g_object_unref, NULL, NULL, NULL);
		_g_object_unref0 (self->priv->_elements);
		self->priv->_elements = _tmp16_;
		{
			gint i;
			i = 0;
			{
				gboolean _tmp17_;
				_tmp17_ = TRUE;
				while (TRUE) {
					gboolean _tmp18_;
					gint _tmp20_;
					GVariant** _tmp21_;
					gint _tmp21__length1;
					GVariant** _tmp22_;
					gint _tmp22__length1;
					gint _tmp23_;
					GVariant* _tmp24_;
					gint _tmp25_ = 0;
					guchar* _tmp26_ = NULL;
					guchar* buff;
					gint buff_length1;
					gint _buff_size_;
					guchar* _tmp27_;
					gint _tmp27__length1;
					zcdBufferOwner* _tmp28_;
					zcdBufferOwner* buf;
					GeeArrayList* _tmp29_;
					zcdBufferOwner* _tmp30_;
					_tmp18_ = _tmp17_;
					if (!_tmp18_) {
						gint _tmp19_;
						_tmp19_ = i;
						i = _tmp19_ + 1;
					}
					_tmp17_ = FALSE;
					_tmp20_ = i;
					_tmp21_ = var_elements;
					_tmp21__length1 = var_elements_length1;
					if (!(_tmp20_ < _tmp21__length1)) {
						break;
					}
					_tmp22_ = var_elements;
					_tmp22__length1 = var_elements_length1;
					_tmp23_ = i;
					_tmp24_ = _tmp22_[_tmp23_];
					_tmp26_ = zcd_serializer_variant_to_uchar_array (_tmp24_, &_tmp25_);
					buff = _tmp26_;
					buff_length1 = _tmp25_;
					_buff_size_ = buff_length1;
					_tmp27_ = buff;
					_tmp27__length1 = buff_length1;
					_tmp28_ = zcd_buffer_owner_new (_tmp27_, _tmp27__length1);
					buf = _tmp28_;
					_tmp29_ = self->priv->_elements;
					_tmp30_ = buf;
					gee_abstract_collection_add ((GeeAbstractCollection*) _tmp29_, _tmp30_);
					_g_object_unref0 (buf);
					buff = (g_free (buff), NULL);
				}
			}
		}
		var_elements = (_vala_array_free (var_elements, var_elements_length1, (GDestroyNotify) g_variant_unref), NULL);
		_g_variant_unref0 (v2);
		_g_variant_unref0 (v1);
	} else {
		GeeArrayList* _tmp31_;
		GVariant* _tmp32_;
		gchar* _tmp33_ = NULL;
		_tmp31_ = gee_array_list_new (ZCD_TYPE_BUFFER_OWNER, (GBoxedCopyFunc) g_object_ref, g_object_unref, NULL, NULL, NULL);
		_g_object_unref0 (self->priv->_elements);
		self->priv->_elements = _tmp31_;
		_tmp32_ = v;
		_tmp33_ = zcd_serializer_variant_to_string (_tmp32_);
		_g_free0 (self->method_name);
		self->method_name = _tmp33_;
	}
	_g_object_unref0 (self->priv->_elements_deserialized);
	self->priv->_elements_deserialized = NULL;
	_g_free0 (vt);
}


gchar* zcd_remote_call_to_string (zcdRemoteCall* self) {
	gchar* result = NULL;
	gchar* _tmp0_;
	gchar* args;
	gchar* _tmp1_;
	gchar* nexttok;
	const gchar* _tmp28_;
	const gchar* _tmp29_ = NULL;
	const gchar* _tmp30_;
	const gchar* _tmp31_ = NULL;
	gchar* _tmp32_ = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = g_strdup ("");
	args = _tmp0_;
	_tmp1_ = g_strdup ("");
	nexttok = _tmp1_;
	{
		GeeArrayList* _tmp2_;
		GeeArrayList* _tmp3_;
		GeeArrayList* _buf_list;
		GeeArrayList* _tmp4_;
		gint _tmp5_;
		gint _tmp6_;
		gint _buf_size;
		gint _buf_index;
		_tmp2_ = self->priv->_elements;
		_tmp3_ = _g_object_ref0 (_tmp2_);
		_buf_list = _tmp3_;
		_tmp4_ = _buf_list;
		_tmp5_ = gee_abstract_collection_get_size ((GeeCollection*) _tmp4_);
		_tmp6_ = _tmp5_;
		_buf_size = _tmp6_;
		_buf_index = -1;
		while (TRUE) {
			gint _tmp7_;
			gint _tmp8_;
			gint _tmp9_;
			GeeArrayList* _tmp10_;
			gint _tmp11_;
			gpointer _tmp12_ = NULL;
			zcdBufferOwner* buf;
			const gchar* _tmp13_;
			const gchar* _tmp14_;
			gchar* _tmp15_;
			const gchar* _tmp16_;
			zcdBufferOwner* _tmp17_;
			guchar* _tmp18_;
			gint _tmp18__length1;
			guchar* _tmp19_;
			gint _tmp19__length1;
			gchar* _tmp20_ = NULL;
			gchar* _tmp21_;
			gchar* _tmp22_;
			gchar* _tmp23_;
			gchar* _tmp24_;
			gchar* _tmp25_;
			gchar* _tmp26_;
			gchar* _tmp27_;
			_tmp7_ = _buf_index;
			_buf_index = _tmp7_ + 1;
			_tmp8_ = _buf_index;
			_tmp9_ = _buf_size;
			if (!(_tmp8_ < _tmp9_)) {
				break;
			}
			_tmp10_ = _buf_list;
			_tmp11_ = _buf_index;
			_tmp12_ = gee_abstract_list_get ((GeeAbstractList*) _tmp10_, _tmp11_);
			buf = (zcdBufferOwner*) _tmp12_;
			_tmp13_ = args;
			_tmp14_ = nexttok;
			_tmp15_ = g_strconcat (_tmp13_, _tmp14_, NULL);
			_g_free0 (args);
			args = _tmp15_;
			_tmp16_ = args;
			_tmp17_ = buf;
			_tmp18_ = zcd_buffer_owner_get_buf (_tmp17_, &_tmp18__length1);
			_tmp19_ = _tmp18_;
			_tmp19__length1 = _tmp18__length1;
			_tmp20_ = zcd_iserializable_typename (_tmp19_, _tmp19__length1);
			_tmp21_ = _tmp20_;
			_tmp22_ = g_strconcat ("[", _tmp21_, NULL);
			_tmp23_ = _tmp22_;
			_tmp24_ = g_strconcat (_tmp23_, "]", NULL);
			_tmp25_ = _tmp24_;
			_tmp26_ = g_strconcat (_tmp16_, _tmp25_, NULL);
			_g_free0 (args);
			args = _tmp26_;
			_g_free0 (_tmp25_);
			_g_free0 (_tmp23_);
			_g_free0 (_tmp21_);
			_tmp27_ = g_strdup (", ");
			_g_free0 (nexttok);
			nexttok = _tmp27_;
			_g_object_unref0 (buf);
		}
		_g_object_unref0 (_buf_list);
	}
	_tmp28_ = self->method_name;
	_tmp29_ = string_to_string (_tmp28_);
	_tmp30_ = args;
	_tmp31_ = string_to_string (_tmp30_);
	_tmp32_ = g_strconcat ("<RemoteCall ", _tmp29_, "(", _tmp31_, ")>", NULL);
	result = _tmp32_;
	_g_free0 (nexttok);
	_g_free0 (args);
	return result;
}


GeeList* zcd_remote_call_get_parameters (zcdRemoteCall* self) {
	GeeList* result;
	GeeArrayList* _tmp0_;
	GeeArrayList* _tmp31_;
	GeeBidirList* _tmp32_;
	GeeBidirList* _tmp33_;
	GeeList* _tmp34_;
	GError * _inner_error_ = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_elements_deserialized;
	if (_tmp0_ == NULL) {
		{
			GeeArrayList* _tmp1_;
			_tmp1_ = gee_array_list_new (ZCD_TYPE_ISERIALIZABLE, (GBoxedCopyFunc) g_object_ref, g_object_unref, (GeeEqualDataFunc) zcd_remote_call_not_impl_equal_func, NULL, NULL);
			_g_object_unref0 (self->priv->_elements_deserialized);
			self->priv->_elements_deserialized = _tmp1_;
			{
				GeeArrayList* _tmp2_;
				GeeArrayList* _tmp3_;
				GeeArrayList* _buf_list;
				GeeArrayList* _tmp4_;
				gint _tmp5_;
				gint _tmp6_;
				gint _buf_size;
				gint _buf_index;
				_tmp2_ = self->priv->_elements;
				_tmp3_ = _g_object_ref0 (_tmp2_);
				_buf_list = _tmp3_;
				_tmp4_ = _buf_list;
				_tmp5_ = gee_abstract_collection_get_size ((GeeCollection*) _tmp4_);
				_tmp6_ = _tmp5_;
				_buf_size = _tmp6_;
				_buf_index = -1;
				while (TRUE) {
					gint _tmp7_;
					gint _tmp8_;
					gint _tmp9_;
					GeeArrayList* _tmp10_;
					gint _tmp11_;
					gpointer _tmp12_ = NULL;
					zcdBufferOwner* buf;
					zcdBufferOwner* _tmp13_;
					guchar* _tmp14_;
					gint _tmp14__length1;
					guchar* _tmp15_;
					gint _tmp15__length1;
					zcdISerializable* _tmp16_ = NULL;
					zcdISerializable* iser;
					GeeArrayList* _tmp17_;
					zcdISerializable* _tmp18_;
					_tmp7_ = _buf_index;
					_buf_index = _tmp7_ + 1;
					_tmp8_ = _buf_index;
					_tmp9_ = _buf_size;
					if (!(_tmp8_ < _tmp9_)) {
						break;
					}
					_tmp10_ = _buf_list;
					_tmp11_ = _buf_index;
					_tmp12_ = gee_abstract_list_get ((GeeAbstractList*) _tmp10_, _tmp11_);
					buf = (zcdBufferOwner*) _tmp12_;
					_tmp13_ = buf;
					_tmp14_ = zcd_buffer_owner_get_buf (_tmp13_, &_tmp14__length1);
					_tmp15_ = _tmp14_;
					_tmp15__length1 = _tmp14__length1;
					_tmp16_ = zcd_iserializable_deserialize (_tmp15_, _tmp15__length1, &_inner_error_);
					iser = _tmp16_;
					if (_inner_error_ != NULL) {
						_g_object_unref0 (buf);
						_g_object_unref0 (_buf_list);
						if (_inner_error_->domain == ZCD_SERIALIZER_ERROR) {
							goto __catch0_zcd_serializer_error;
						}
						_g_object_unref0 (buf);
						_g_object_unref0 (_buf_list);
						g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
						g_clear_error (&_inner_error_);
						return NULL;
					}
					_tmp17_ = self->priv->_elements_deserialized;
					_tmp18_ = iser;
					gee_abstract_collection_add ((GeeAbstractCollection*) _tmp17_, _tmp18_);
					_g_object_unref0 (iser);
					_g_object_unref0 (buf);
				}
				_g_object_unref0 (_buf_list);
			}
		}
		goto __finally0;
		__catch0_zcd_serializer_error:
		{
			GError* e = NULL;
			GError* _tmp19_;
			GQuark _tmp20_;
			const gchar* _tmp21_ = NULL;
			GError* _tmp22_;
			gint _tmp23_;
			gchar* _tmp24_ = NULL;
			gchar* _tmp25_;
			GError* _tmp26_;
			const gchar* _tmp27_;
			const gchar* _tmp28_ = NULL;
			gchar* _tmp29_ = NULL;
			gchar* _tmp30_;
			e = _inner_error_;
			_inner_error_ = NULL;
			_tmp19_ = e;
			_tmp20_ = _tmp19_->domain;
			_tmp21_ = g_quark_to_string (_tmp20_);
			_tmp22_ = e;
			_tmp23_ = _tmp22_->code;
			_tmp24_ = g_strdup_printf ("%i", _tmp23_);
			_tmp25_ = _tmp24_;
			_tmp26_ = e;
			_tmp27_ = _tmp26_->message;
			_tmp28_ = string_to_string (_tmp27_);
			_tmp29_ = g_strconcat ("RemoteCall: Caught exception while deserializing parameters ", _tmp21_, " code ", _tmp25_, ": ", _tmp28_, NULL);
			_tmp30_ = _tmp29_;
			zcd_log_error (_tmp30_);
			_g_free0 (_tmp30_);
			_g_free0 (_tmp25_);
			_g_error_free0 (e);
		}
		__finally0:
		if (_inner_error_ != NULL) {
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return NULL;
		}
	}
	_tmp31_ = self->priv->_elements_deserialized;
	_tmp32_ = gee_abstract_bidir_list_get_read_only_view ((GeeAbstractBidirList*) _tmp31_);
	_tmp33_ = _tmp32_;
	_g_object_unref0 (self->priv->_elements_deserialized_ro);
	self->priv->_elements_deserialized_ro = (GeeList*) _tmp33_;
	_tmp34_ = self->priv->_elements_deserialized_ro;
	result = _tmp34_;
	return result;
}


static void zcd_remote_call_class_init (zcdRemoteCallClass * klass) {
	zcd_remote_call_parent_class = g_type_class_peek_parent (klass);
	g_type_class_add_private (klass, sizeof (zcdRemoteCallPrivate));
	G_OBJECT_CLASS (klass)->get_property = _vala_zcd_remote_call_get_property;
	G_OBJECT_CLASS (klass)->finalize = zcd_remote_call_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), ZCD_REMOTE_CALL_PARAMETERS, g_param_spec_object ("parameters", "parameters", "parameters", GEE_TYPE_LIST, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE));
}


static void zcd_remote_call_zcd_iserializable_interface_init (zcdISerializableIface * iface) {
	zcd_remote_call_zcd_iserializable_parent_iface = g_type_interface_peek_parent (iface);
	iface->serialize_to_variant = (GVariant* (*)(zcdISerializable*)) zcd_remote_call_real_serialize_to_variant;
	iface->deserialize_from_variant = (void (*)(zcdISerializable*, GVariant*, GError**)) zcd_remote_call_real_deserialize_from_variant;
}


static void zcd_remote_call_instance_init (zcdRemoteCall * self) {
	self->priv = ZCD_REMOTE_CALL_GET_PRIVATE (self);
	self->priv->_elements_deserialized = NULL;
	self->priv->_elements_deserialized_ro = NULL;
}


static void zcd_remote_call_finalize (GObject* obj) {
	zcdRemoteCall * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, ZCD_TYPE_REMOTE_CALL, zcdRemoteCall);
	_g_free0 (self->method_name);
	_g_object_unref0 (self->priv->_elements);
	_g_object_unref0 (self->priv->_elements_deserialized);
	_g_object_unref0 (self->priv->_elements_deserialized_ro);
	G_OBJECT_CLASS (zcd_remote_call_parent_class)->finalize (obj);
}


/** This class represents a call to a remotable procedure.
      *
      * The string method_name contains something like "property1.property2.method0"
      * which means that in the remote host the Dispatcher object has a
      * property "property1", that has a property "property2", that has
      * a remotable method "method0".
      * The array _elements contains the parameters (in serialized form) of the method.
      */
GType zcd_remote_call_get_type (void) {
	static volatile gsize zcd_remote_call_type_id__volatile = 0;
	if (g_once_init_enter (&zcd_remote_call_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (zcdRemoteCallClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) zcd_remote_call_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (zcdRemoteCall), 0, (GInstanceInitFunc) zcd_remote_call_instance_init, NULL };
		static const GInterfaceInfo zcd_iserializable_info = { (GInterfaceInitFunc) zcd_remote_call_zcd_iserializable_interface_init, (GInterfaceFinalizeFunc) NULL, NULL};
		GType zcd_remote_call_type_id;
		zcd_remote_call_type_id = g_type_register_static (G_TYPE_OBJECT, "zcdRemoteCall", &g_define_type_info, 0);
		g_type_add_interface_static (zcd_remote_call_type_id, ZCD_TYPE_ISERIALIZABLE, &zcd_iserializable_info);
		g_once_init_leave (&zcd_remote_call_type_id__volatile, zcd_remote_call_type_id);
	}
	return zcd_remote_call_type_id__volatile;
}


static void _vala_zcd_remote_call_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec) {
	zcdRemoteCall * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, ZCD_TYPE_REMOTE_CALL, zcdRemoteCall);
	switch (property_id) {
		case ZCD_REMOTE_CALL_PARAMETERS:
		g_value_set_object (value, zcd_remote_call_get_parameters (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}


static void _vala_array_destroy (gpointer array, gint array_length, GDestroyNotify destroy_func) {
	if ((array != NULL) && (destroy_func != NULL)) {
		int i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}


static void _vala_array_free (gpointer array, gint array_length, GDestroyNotify destroy_func) {
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}



